"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@fluentui/react");
const theme = (0, react_2.getTheme)();
const useStyles = (0, react_2.makeStyles)(() => ({
    root: {
        fontSize: 12,
        fontWeight: 500,
        minHeight: 32,
        display: 'inline-flex',
        wordBreak: 'break-word',
        flexDirection: 'column',
        justifyContent: 'center',
        color: theme.semanticColors.messageText,
        padding: '0 10px',
    },
    info: {
        background: theme.semanticColors.infoBackground
    },
    success: {
        background: theme.semanticColors.successBackground
    },
    error: {
        background: theme.semanticColors.errorBackground
    },
}));
const Status = (props) => {
    const { type, children } = props;
    const classNames = useStyles();
    return react_1.default.createElement("span", { className: `${classNames.root} ${(classNames === null || classNames === void 0 ? void 0 : classNames[type]) || (classNames === null || classNames === void 0 ? void 0 : classNames.info)}` }, children);
};
exports.default = Status;
