"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_2 = require("@fluentui/react");
const hoc_1 = require("../helpers/hoc");
const loading_bar_1 = __importDefault(require("../components/loading-bar"));
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const react_hook_form_1 = require("react-hook-form");
// eslint-disable-next-line max-len
const dynamic_form_1 = require("./dynamic-form");
const classnames_1 = __importDefault(require("classnames"));
const posts_context_1 = require("../features/posts/context/posts.context");
const uuid_1 = require("uuid");
const posts_select_panel_1 = __importDefault(require("../features/posts/components/posts-select-panel"));
const status_1 = __importDefault(require("../components/status"));
const theme = (0, react_2.getTheme)();
const styles = (0, react_2.mergeStyleSets)({
    headingWrapper: {
        display: 'flex',
        flexDirection: 'row',
        alignItems: 'center',
        justifyContent: 'space-between',
    },
    draggable: {
        padding: 20,
        border: `1px solid ${theme.palette.neutralLight}`,
    },
    draggableMargin: {
        marginBottom: 15,
    },
    component: {
        position: 'relative',
    },
});
const DynamicReferencesComponentImpl = ({ name, slugPath, onDelete, disableDown, disableUp, onMove }) => {
    var _a, _b;
    const { control, disabled } = (0, dynamic_form_1.useExtendedFormContext)();
    const { setLoadingContent, getBySlug } = (0, posts_context_1.usePosts)();
    (0, react_1.useEffect)(() => {
        if (slugPath) {
            getBySlug.execute(slugPath);
        }
    }, [slugPath]);
    (0, react_1.useEffect)(() => {
        const id = (0, uuid_1.v4)();
        setLoadingContent(id, getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading);
        return () => {
            setLoadingContent(id, false);
        };
    }, [getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading]);
    return (react_1.default.createElement("div", { className: styles.component },
        react_1.default.createElement("div", { className: styles.headingWrapper },
            react_1.default.createElement(react_2.Stack, { style: {
                    overflowX: 'auto',
                    alignItems: 'flex-start',
                } },
                react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(react_2.Label, { style: { overflow: 'hidden', wordBreak: 'break-all' } }, slugPath),
                    (getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.error) ? (react_1.default.createElement(status_1.default, { type: "error" }, "Invalid post")) : (react_1.default.createElement(status_1.default, { type: ((_a = getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.result) === null || _a === void 0 ? void 0 : _a.status) === 'published'
                            ? 'success'
                            : undefined }, (_b = getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.result) === null || _b === void 0 ? void 0 : _b.status)))),
            react_1.default.createElement(react_2.Stack, { horizontal: true, tokens: { childrenGap: 8 } },
                react_1.default.createElement(react_2.IconButton, { disabled: (getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading) || !!(getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.error), iconProps: {
                        iconName: 'OpenInNewTab',
                    }, title: "Open in new tab", onClick: () => {
                        var _a;
                        window.open(`/admin/sites/editor/${(_a = getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.result) === null || _a === void 0 ? void 0 : _a.id}`, '_blank');
                    } }),
                react_1.default.createElement(react_2.IconButton, { disabled: (getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading) || disabled || disableUp, onClick: () => onMove(-1), iconProps: { iconName: 'Up' }, title: "Move Up", ariaLabel: "Move Up" }),
                react_1.default.createElement(react_2.IconButton, { disabled: (getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading) || disabled || disableDown, onClick: () => onMove(1), iconProps: { iconName: 'Down' }, title: "Move Down", ariaLabel: "Move Down" }),
                react_1.default.createElement(react_2.IconButton, { iconProps: { iconName: 'Delete' }, disabled: (getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading) || disabled, title: "Delete", ariaLabel: "Delete", onClick: () => onDelete() }))),
        react_1.default.createElement(loading_bar_1.default, { loading: getBySlug === null || getBySlug === void 0 ? void 0 : getBySlug.loading },
            react_1.default.createElement(react_hook_form_1.Controller, { name: `${name}.slugPath`, control: control, defaultValue: slugPath, render: ({ field }) => {
                    (0, react_1.useEffect)(() => {
                        field.onChange(slugPath);
                    }, []);
                    return null;
                } }))));
};
const DynamicReferencesComponent = (0, hoc_1.composeWrappers)({
    postsContext: posts_context_1.PostsContextProvider,
})(DynamicReferencesComponentImpl);
const DynamicReferences = ({ field, name, }) => {
    var _a;
    const [selectPostOpen, setSelectPostOpen] = (0, react_1.useState)(false);
    const { control, disabled, narrow } = (0, dynamic_form_1.useExtendedFormContext)();
    const { fields, append, remove, move } = (0, react_hook_form_1.useFieldArray)({
        control,
        name,
    });
    const getItemStyle = (isDragging, draggableStyle) => {
        if (isDragging) {
            return Object.assign({ backgroundColor: theme.palette.neutralLighterAlt, boxShadow: theme.effects.elevation8, userSelect: 'none' }, draggableStyle);
        }
        return Object.assign({}, draggableStyle);
    };
    const onDragEnd = (result) => {
        var _a, _b;
        // dropped outside the list
        if (!result.destination) {
            return;
        }
        move((_a = result === null || result === void 0 ? void 0 : result.source) === null || _a === void 0 ? void 0 : _a.index, (_b = result === null || result === void 0 ? void 0 : result.destination) === null || _b === void 0 ? void 0 : _b.index);
    };
    return (react_1.default.createElement("div", null,
        ((_a = field === null || field === void 0 ? void 0 : field.label) === null || _a === void 0 ? void 0 : _a.length) > 0 && (react_1.default.createElement(react_2.Label, null, `${field === null || field === void 0 ? void 0 : field.label} (Multiple)`)),
        react_1.default.createElement(react_beautiful_dnd_1.DragDropContext, { onDragEnd: onDragEnd },
            react_1.default.createElement(react_beautiful_dnd_1.Droppable, { droppableId: name }, (provided) => (react_1.default.createElement("div", Object.assign({}, provided.droppableProps, { ref: provided.innerRef }),
                react_1.default.createElement(react_2.Stack, { tokens: { childrenGap: 10 } },
                    (fields || []).map((formField, index) => (react_1.default.createElement(react_beautiful_dnd_1.Draggable, { isDragDisabled: disabled, key: formField.id, draggableId: formField.id, index: index }, (provided, snapshot) => {
                        var _a;
                        return (react_1.default.createElement("div", Object.assign({ ref: provided.innerRef }, provided.draggableProps, provided.dragHandleProps, { style: getItemStyle(snapshot.isDragging, provided.draggableProps.style), className: (0, classnames_1.default)([
                                styles.draggable,
                                !narrow && styles.draggableMargin,
                            ]) }),
                            react_1.default.createElement(DynamicReferencesComponent, { onDelete: () => {
                                    remove(index);
                                }, onMove: (offset) => {
                                    move(index, index + offset);
                                }, disableDown: index >= (fields === null || fields === void 0 ? void 0 : fields.length) - 1, disableUp: index === 0, name: `${name}[${index}]`, slugPath: (_a = formField) === null || _a === void 0 ? void 0 : _a.slugPath, field: {
                                    fields: field === null || field === void 0 ? void 0 : field.fields,
                                } })));
                    }))),
                    provided.placeholder))))),
        react_1.default.createElement(react_2.Separator, { style: { marginTop: 30 } },
            react_1.default.createElement(react_2.ActionButton, { disabled: disabled, iconProps: {
                    iconName: 'Add',
                }, onClick: () => {
                    setSelectPostOpen(true);
                } }, "Add reference")),
        react_1.default.createElement(posts_select_panel_1.default, { isOpen: selectPostOpen, selectionMode: react_2.SelectionMode.single, onDismiss: () => setSelectPostOpen(false), onSubmit: (data) => {
                var _a;
                append({
                    slugPath: (_a = data === null || data === void 0 ? void 0 : data[0]) === null || _a === void 0 ? void 0 : _a.slugPath
                });
                setSelectPostOpen(false);
            }, params: {
                contentTypeName: field.posts,
            } })));
};
exports.default = DynamicReferences;
