"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compareSync = exports.hashSync = exports.compare = exports.hash = void 0;
const bcrypt = __importStar(require("bcryptjs"));
const defer_promise_1 = __importDefault(require("defer-promise"));
const roundsDef = 10;
const hash = (string, rounds) => __awaiter(void 0, void 0, void 0, function* () {
    const deferred = (0, defer_promise_1.default)();
    bcrypt.hash(string, rounds || roundsDef, (err, hashString) => {
        if (err)
            return deferred.reject(err);
        return deferred.resolve(hashString);
    });
    return deferred.promise;
});
exports.hash = hash;
const hashSync = (string, rounds) => {
    return bcrypt.hashSync(string, rounds || roundsDef);
};
exports.hashSync = hashSync;
const compare = (string, hashString) => __awaiter(void 0, void 0, void 0, function* () {
    const deferred = (0, defer_promise_1.default)();
    bcrypt.compare(string, hashString, (err, result) => {
        if (err) {
            deferred.resolve(false);
        }
        else {
            deferred.resolve(Boolean(result));
        }
    });
    return deferred.promise;
});
exports.compare = compare;
const compareSync = (string, hashString) => bcrypt.compareSync(string, hashString);
exports.compareSync = compareSync;
